#pragma once

#include <cstdint> // TODO
#include <string>
#include <typeinfo>

namespace armarx::aron
{
    // default implementation
    template <typename T>
    struct TypeName
    {
        static const char*
        Get()
        {
            return typeid(T).name();
        }
    };

    template <>
    struct TypeName<short>
    {
        static const char*
        Get()
        {
            return "short";
        }
    };

    template <>
    struct TypeName<int>
    {
        static const char*
        Get()
        {
            return "int";
        }
    };

    template <>
    struct TypeName<float>
    {
        static const char*
        Get()
        {
            return "float";
        }
    };

    template <>
    struct TypeName<long>
    {
        static const char*
        Get()
        {
            return "long";
        }
    };

    template <>
    struct TypeName<double>
    {
        static const char*
        Get()
        {
            return "double";
        }
    };

    template <>
    struct TypeName<std::string>
    {
        static const char*
        Get()
        {
            return "string";
        }
    };

    template <>
    struct TypeName<bool>
    {
        static const char*
        Get()
        {
            return "bool";
        }
    };
} // namespace armarx::aron
