/*
 * This file is part of ArmarX.
 *
 * Copyright (C) 2012-2016, High Performance Humanoid Technologies (H2T),
 * Karlsruhe Institute of Technology (KIT), all rights reserved.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Fabian Peller-Konrad (fabian dot peller-konrad at kit dot edu)
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

// Header
#include "IntEnum.h"

namespace armarx::aron::type
{
    // constructors
    IntEnum::IntEnum(const Path& path) : Base(type::Descriptor::INT_ENUM, path)
    {
    }

    IntEnum::IntEnum(const type::dto::IntEnum& o, const Path& path) :
        Base(o, type::Descriptor::INT_ENUM, path)
    {
    }

    type::dto::IntEnumPtr
    IntEnum::toIntEnumDTO() const
    {
        return this->aron;
    }

    // virtual implementations
    std::string
    IntEnum::getShortName() const
    {
        return "IntEnum";
    }

    std::string
    IntEnum::getFullName() const
    {
        return "armarx::aron::type::IntEnum";
    }
} // namespace armarx::aron::type
