#pragma once

#include <string>
#include <vector>

#include <RobotAPI/interface/skills/SkillManagerInterface.h>
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>

namespace armarx
{
    namespace skills
    {
        class SkillID;

        class ProviderID
        {
        public:
            static const constexpr char* PREFIX_SEPARATOR = "->";

            std::string providerName;

            ProviderID() = delete;
            ProviderID(const skills::SkillID& skillid);
            ProviderID(const std::string& pName);

            bool operator==(const ProviderID& other) const;
            bool operator!=(const ProviderID& other) const;
            bool operator<(const ProviderID& other) const;

            manager::dto::ProviderID toManagerIce() const;
            callback::dto::ProviderID toCallbackIce() const;

            static ProviderID FromIce(const manager::dto::ProviderID&);
            static ProviderID FromIce(const callback::dto::ProviderID&);

            std::string toString(const std::string& prefix = "") const;
        };

        std::ostream& operator<<(std::ostream& os, const ProviderID& id);
    } // namespace skills
} // namespace armarx
