#pragma once

#include <string>
#include <vector>

#include <SimoxUtility/algorithm/string.h>

#include <RobotAPI/interface/skills/SkillManagerInterface.h>

#include "ProviderID.h"
#include "SkillDescription.h"
#include "SkillID.h"
#include "error/Exception.h"

namespace armarx
{
    namespace skills
    {
        class ProviderInfo
        {
        public:
            ProviderID providerId;
            provider::dti::SkillProviderInterfacePrx providerInterface;
            std::map<SkillID, SkillDescription> providedSkills;

            ProviderInfo() = delete;
            ProviderInfo(const ProviderID& pid,
                         const provider::dti::SkillProviderInterfacePrx& i,
                         const std::map<SkillID, SkillDescription>& skills);

            skills::manager::dto::ProviderInfo toIce() const;

            static ProviderInfo FromIce(const manager::dto::ProviderInfo&);
        };
    } // namespace skills
} // namespace armarx
