#pragma once

#include <RobotAPI/libraries/skills/core/Skill.h>

namespace armarx
{
    namespace skills
    {
        /* Manages the remote execution of a skill and converts the ice types */
        class SkillProxy : public armarx::Logging
        {
        public:
            SkillProxy(const manager::dti::SkillManagerInterfacePrx& manager,
                       const SkillID& skillId);
            SkillProxy(const manager::dti::SkillManagerInterfacePrx& manager,
                       const SkillDescription& skillDesc);

            // Provide a similar API as the skillprovider
            TerminatedSkillStatusUpdate executeSkill(const std::string& executorName,
                                                const aron::data::DictPtr& params = nullptr);

            SkillExecutionID executeSkillAsync(const std::string& executorName,
                                          const aron::data::DictPtr& params = nullptr);

            void abortSkill(const SkillExecutionID& executorName);

            // Utiliy methods
            aron::data::DictPtr getDefaultParameters(const std::string& profileName = "root");

        private:
            manager::dti::SkillManagerInterfacePrx manager;
            SkillDescription skillDescription;
        };
    } // namespace skills
} // namespace armarx
